#!/usr/bin/perl

use strict;
use warnings;

my $count;
my $rand;
my $numArgs = $#ARGV + 1;
my $filecount;

if($numArgs < 1)
{
	print "Need some filesnames...\n";
	die $!;
}

for ($filecount = 0; $filecount < $numArgs; $filecount++) {
	$count = 0;
	open FILE, "$ARGV[$filecount]" or die $!;
	my $filename = ">" . $ARGV[$filecount] . "_ru";
	my $opened = open NEWFILE, $filename;

	if( ! $opened ){
		print "Error!";
		close FILE;
		exit 1;
	}

	while (my $line = <FILE>) {
		if($count > 4)
		{
			my @values = split(' ',$line);

			$rand = int( rand(int($values[2])/100)) + 1;

			chomp($line);

			print NEWFILE "$line\t$rand\n";
		} else {
			print NEWFILE "$line";
		}

		$count++;
	}

	close NEWFILE;
	close FILE;
}

exit 0;

