/* chronos/rtdvs/dra_ote.c
 *
 * DRA_OTE Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Sonal Saha, sonal3@vt.edu
 *
 * Copyright (C) 2009-2011 Virginia Tech Real Time Systems Lab
 */



#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <linux/time.h>
#include <linux/chronos_util.h>
#include <asm/current.h>
#include <linux/sched.h>
#include <linux/chronos_sched.h>
////////////////IMP!!!!!!!!!!!! task->buffer2 is remi!!!!!!!!!!!!!!!!!!!!!!!!!\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


/*
struct alpha_member {
        int i;
        int i_end;
	unsigned long deadline;
        long left;
        long rem_time;
        unsigned long wcet_can;
      struct list_head list;
}; 
*/


struct dra_ote_member{

unsigned long deadline;
unsigned long period;
unsigned long next_arrival_time;

};

struct nta_member{

unsigned long deadline;
unsigned long period;
unsigned long next_arrival_time;

};

static long calc_left_dra(struct rt_info *task)
{
	long left = 0;

	left = 100*(task->exec_time)/(task->util_taskset) - task_time(task);//83
	return (left <= 0) ? 1 : left;
}

static long update_left_dra(struct rt_info *task)
{
	long left = 0;

	left = calc_left_dra(task);
	long_to_timespec(left, &(task->left));
	return left;
}

static int prev_high_speed;
static long end_high_int=0;
static int cnt=0,pl=0;
struct rt_info* sched_dra_ote(struct list_head *head, int flags)
{       
         int cpu=0;
         struct cpufreq_policy *policy=NULL;
         struct rt_info *it = NULL;
         long total_u=0;
         struct task_struct *p,*p1;
	 struct rt_info *task=NULL;
         struct rt_info *task1=NULL;
         int flag=0;
         long task_full_load=0;
         long task_prev_load=0;
         static long total_u_prev=0;
         struct mutex_data *mutex_k;
         policy=per_cpu(cpufreq_cpu_data,cpu);
         long max_blk_sec; 
         //int end_high_int;
         long deadline_blocking;
         static int cnt1=0;
         static int i=0;
         static int i_end=0;
       static struct alpha_member a[1500];
      // static struct alpha_member *b=NULL;
       struct alpha_member *it_alpha=NULL;
  
    cnt++;
     p++;
        struct list_head *curr;
        struct rt_info *best_per = NULL, *last_per = NULL;
        int utilization, speed, high_speed;
         struct rt_info *prev_task=NULL;
     static   struct rt_info *head_temp=NULL;

       long  extra_time_fr_best=0;
           int check_flag=0;
           int task_q_counter=0;
        

         p=current;
         task = &(p->rtinfo);
         struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);
         flag=!list_empty(&task->task_list[0]);
          
         total_u =best->util_taskset;
       //  head_temp=head->next;
         struct list_head *pos, *q;
        static  struct alpha_member b;
         if (cnt==1) INIT_LIST_HEAD(&b.list);
         struct alpha_member *tmp,*tmp_next;
         struct list_head *ptr, *ptr_temp;
         struct alpha_member *entry, *entry_temp;
          int mark=0;
         struct timespec curr_time;
         static long prev_time;
         long time_diff;
        static long best_left;
         struct dra_ote_member d_curr[30];
         static struct dra_ote_member d_prev[30];
         int task_counter=0;
         static int initial_dra_counter=0;
        initial_dra_counter++;
        static struct nta_member nta[40];
        static long act_next_arrival_time=0;
        static int final_task_counter;
        int k=0;
         static  struct timespec curr_time_dra;
          static int i_flag=0;

    list_for_each(curr, head) {
              it = list_entry(curr, struct rt_info, task_list[0]);
                         if((it->total_util)==0){
                             if (i_flag==0){
                               i=0;
                               }
                           it->total_util=best->util_taskset;///check this value
                        }
                  i_flag=1;
           }




      if((flag==1)&&(task->flag_begin_end_check==200)){
                
               cnt1++;

               initialize_lists(task);
               
		   a[i].deadline = timespec_to_long(&(task->deadline));
		   a[i].i=i;
                   a[i].wcet_can=  ((task->exec_time)*100)/(best->util_taskset);//
                   a[i].rem_time=  ((task->exec_time)*100)/(best->util_taskset);//
            
                    pos=&b.list;
                   pos= pos->prev;
                   tmp=list_entry(pos, struct alpha_member, list);
                   curr_time = current_kernel_time();
                  
                      if (cnt1==1) prev_time=timespec_to_long(&(curr_time));
                 
               
                   time_diff=timespec_to_long(&(curr_time))-prev_time;
                    prev_time= timespec_to_long(&(curr_time));
                
                 
                   pos=&b.list;
                   pos= pos->prev;
      
          while(pos!= &b.list){
                         
		                tmp= list_entry(pos, struct alpha_member, list);
                                tmp->rem_time = tmp->rem_time - time_diff;
                                trace_printk("time_diff is= %ld\n",time_diff );
                                   if(tmp->rem_time >0)break;
                               list_del(pos);
                               trace_printk(" Deleting  i=%d\n",tmp->i);
                               pos=&b.list;
                               pos= pos->prev;
                               time_diff= (-1)*(tmp->rem_time);
		         }
                               

                   
		   b.deadline=10;
		   ptr= &b.list.next;
		   entry = list_entry(ptr, struct alpha_member, list);
		 
   
 
	     do {
		       mark=0;
		       ptr=ptr->next;
		       ptr_temp=ptr->next;
		       entry = list_entry(ptr, struct alpha_member, list);
			  if ( entry->deadline > a[i].deadline) {
				
				entry_temp = list_entry(ptr->next, struct alpha_member, list);
		  
					  while((a[i].deadline)<(entry_temp->deadline)&&(ptr!=&b.list)){

						  ptr=ptr_temp; 
						  ptr_temp=ptr_temp->next;
						 entry_temp = list_entry(ptr_temp, struct alpha_member, list);   
					  }

			      
				mark=1;
			       list_add(&(a[i].list), ptr);
			      break;
			   }
		
	       
	       }while(ptr!=&b.list);

            if (mark!=1)list_add(&(a[i].list), &(b.list));
     
                    i++;
                  
                trace_printk("the value of i = %d\n",i);
                trace_printk("Scheduler invoked from beginrtseg\n");

                
                        
              list_for_each(curr, head){
                  it = list_entry(curr, struct rt_info, task_list[0]);
           trace_printk("ACTUAL in begin :ddline =%ld and wcet =%ld and left=%ld\n",timespec_to_long(&(it->deadline)),((it->exec_time)*100/(it->util_taskset)),update_left_dra(it)); 
                }                


              list_for_each(pos, &b.list){
                        tmp= list_entry(pos, struct alpha_member, list);
                        tmp_next= list_entry(pos->next, struct alpha_member, list);
                        if((tmp->deadline==tmp_next->deadline)&&(tmp->wcet_can==tmp_next->wcet_can))list_del(pos);
                      
                       trace_printk("ALPHA_begin :ddline =%ld and i=%d and wcet_can =%ld and rem_time=%ld\n",tmp->deadline,tmp->i,tmp->wcet_can,tmp->rem_time); 

                 }      

                
                    trace_printk("ACTUAL_BEST_begin:ddline =%ld and wcet_can =%ld and left =%ld\n",timespec_to_long(&(best->deadline)),((best->exec_time)*100/83),update_left_dra(best)); 
                      best_left=update_left_dra(best);
         
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 curr_time = current_kernel_time();
   trace_printk("Current kernel time is = %ld\n",timespec_to_long(&(curr_time)));
     list_for_each(curr, head){
		      it = list_entry(curr, struct rt_info, task_list[0]);
		      d_curr[task_counter].deadline=timespec_to_long(&(it->deadline));
		      d_curr[task_counter].period=timespec_to_long(&(it->period));
		      d_curr[task_counter].next_arrival_time= timespec_to_long(&(curr_time))+ d_curr[task_counter].period;

		       if(initial_dra_counter!=1){
		            for(k=0;k<=final_task_counter;k++){
                           //   trace_printk("nta[%d].period=%ld,nta[%d].next_arrival_time=%ld\n",k,nta[k].period,k,nta[k].next_arrival_time); 
		            	 if((d_curr[task_counter].period==nta[k].period)&&(d_curr[task_counter].deadline!=nta[k].deadline)){
		                   	  if(d_curr[task_counter].next_arrival_time>=nta[k].next_arrival_time){
		                     	     nta[k].next_arrival_time=d_curr[task_counter].next_arrival_time;
		                    	   }
                                 }
		             } 
		       }
              
        		  if ( initial_dra_counter==1){
               				nta[task_counter].period= timespec_to_long(&(it->period));       
               				nta[task_counter].next_arrival_time=d_curr[task_counter].next_arrival_time;
                                        nta[task_counter].deadline=d_curr[task_counter].deadline;
                                       final_task_counter=task_counter;
                                   trace_printk("final_task_counter=%d\n",final_task_counter);
                           }
              task_counter++;
      }

          if(initial_dra_counter!=1){
                 for(k=0;k<=final_task_counter;k++){
                      trace_printk("nta[%d].period=%ld,nta[%d].next_arrival_time=%ld\n",k,nta[k].period,k,nta[k].next_arrival_time); 
                  }
           }   


		 if ( initial_dra_counter==1){
		      for (k=0;k<task_counter;k++){
		              trace_printk("nta[%d].period=%ld,nta[%d].next_arrival_time=%ld\n",k,nta[k].period,k,nta[k].next_arrival_time); 
		       }
		  }
     int j=0;
          act_next_arrival_time=nta[0].next_arrival_time;
        if(initial_dra_counter!=1){
		  for(j=0;j<final_task_counter;j++){
		             act_next_arrival_time=(nta[j].next_arrival_time < act_next_arrival_time)?nta[j].next_arrival_time:act_next_arrival_time;       
		    }
          }
        trace_printk("act_next_arrival_time=%ld\n",act_next_arrival_time);      
     curr_time_dra = current_kernel_time();
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    }        

         

    if(task->flag_begin_end_check==100){
              trace_printk("Scheduler invoked from  endrtseg\n");

           //    list_del(&task->a_mem.list);

                   pos=&b.list;
                   pos= pos->prev;
                   tmp=list_entry(pos, struct alpha_member, list);
                   curr_time = current_kernel_time();
                   //   if (cnt1==1) prev_time=timespec_to_long(&(curr_time));
               
               //       trace_printk("end:: prev_time= %ld\n",prev_time);
                 //     trace_printk("end:: curr_time = %ld\n",timespec_to_long(&(curr_time)));
               
                   time_diff=timespec_to_long(&(curr_time))-prev_time;
                    prev_time= timespec_to_long(&(curr_time));


             
                   pos=&b.list;
                   pos= pos->prev;
      
     while(pos!= &b.list){
                         
		                tmp= list_entry(pos, struct alpha_member, list);
                                tmp->rem_time = tmp->rem_time - time_diff;
                    trace_printk("time_diff is= %ld\n",time_diff );
                    //trace_printk("HEAD1 in end ::alpha_mmber.ddline =%ld i=%d wcet_can=%ld rem_t=%ld\n",tmp->deadline,tmp->i,tmp->wcet_can,tmp->rem_time);
                                   if(tmp->rem_time >0)break;
                                  list_del(pos);
                                 trace_printk(" Deleting  i=%d\n",tmp->i); 
                                    pos=&b.list;
                                    pos= pos->prev;
                                 time_diff= (-1)*(tmp->rem_time);
		       }

                 list_for_each(curr, head){
                  it = list_entry(curr, struct rt_info, task_list[0]);
           trace_printk("ACTUAL in end :ddline =%ld and wcet =%ld and left=%ld\n",timespec_to_long(&(it->deadline)),((it->exec_time)*100/(it->util_taskset)),update_left_dra(it)); 
                }  


                    list_for_each(pos, &b.list){
                        tmp= list_entry(pos, struct alpha_member, list);
                       trace_printk("ALPHA_END:ddline =%ld and i=%d and wcet_can =%ld and rem_time=%ld\n",tmp->deadline,tmp->i,tmp->wcet_can,tmp->rem_time); 

                 }             

                 i_end++;
       trace_printk("ACTUAL_BEST_end:ddline =%ld and wcet_can =%ld and left =%ld\n",timespec_to_long(&(best->deadline)),((best->exec_time)*100/(it->util_taskset)),update_left_dra(best)); 

         best_left=update_left_dra(best);   
        curr_time_dra = current_kernel_time();         
       }
         
         
           if((task->flag_begin_end_check!=100)&&(flag!=1)){
         //     trace_printk("Scheduler invoked from any other event\n");  
         }  
         
                 extra_time_fr_best=0;
                 check_flag=0;

                
       if (list_empty(&b.list)==0){


           list_for_each_prev(pos, &b.list){

                        tmp= list_entry(pos, struct alpha_member, list);

                //        if((best->deadline>tmp->deadline)&&(((100*best->exec_time)/83)==tmp->wcet_can)){
                             if(timespec_to_long(&(best->deadline))>tmp->deadline){
                              extra_time_fr_best= extra_time_fr_best+ tmp->rem_time;
                              }
                             
                             if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)!=tmp->wcet_can)&&(check_flag==0))
                               {
                                  extra_time_fr_best= extra_time_fr_best+ tmp->rem_time;
                               }


                            if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)==tmp->wcet_can))
                                 {
                                 extra_time_fr_best= extra_time_fr_best+ tmp->rem_time;
                                   check_flag=1;
                                   break;
                                 }

                 }   

        }
              
  //            trace_printk(" extra_time_fr_best=%ld\n",extra_time_fr_best);

  //            trace_printk(" update_left_dra(best)=%ld\n",update_left_dra(best));
              
          //     best_left=update_left_dra(best);

       
          if(extra_time_fr_best==0)total_u=1000*best->util_taskset;
           else{
            total_u=1000* (best->util_taskset*(best_left))/extra_time_fr_best;
            }
             total_u=total_u/1000;
          
         if(total_u >best->util_taskset)total_u=best->util_taskset;

          trace_printk(" total_u_before=%d\n", total_u);

          task_q_counter=0;
         list_for_each(curr, head){
            task_q_counter++;
            }
   
     
    if (task_q_counter==1){
   //     curr_time = current_kernel_time();
        trace_printk("Current kernel time is = %ld\n",timespec_to_long(&(curr_time_dra)));
        trace_printk("act_next_arrival_time = %ld\n",act_next_arrival_time);
      extra_time_fr_best=act_next_arrival_time-timespec_to_long(&(curr_time_dra));
       trace_printk("extra_time_fr_best = %ld\n",extra_time_fr_best);
         trace_printk("best_left = %ld\n",best_left);
       if (extra_time_fr_best>best_left){
           total_u=1000* (total_u*(best_left))/extra_time_fr_best;
         }
       else total_u=1000*total_u;
    /* if(extra_time_fr_best<=0)total_u=1000*total_u;
           else if(extra_time_fr_best>0){
            total_u=1000* (total_u*(best_left))/extra_time_fr_best;
            }*/

             total_u=total_u/1000;
      }
    



      trace_printk(" total_u_after=%d\n", total_u);
        if((total_u)<= 49){
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);
           best->total_util=49;
        }  
        if(((total_u)> 49) && ((total_u)<= 55) ){
             __cpufreq_driver_target(policy, 1380000,CPUFREQ_RELATION_H);
              best->total_util=55;
        }
        if(((total_u)> 55) && ((total_u)<= 61) ){
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
              best->total_util=61;
        }

        if(((total_u)> 61) && ((total_u)<= 66) ){
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
              best->total_util=66;
        }
        if(((total_u)> 66) && ((total_u)<= 72) ){
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
                best->total_util=72;
        }
        if(((total_u)> 72) && ((total_u)<= 77) ){
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
             best->total_util=77;
        }
        if(((total_u)> 77) && ((total_u)<= 83) ){
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
             best->total_util=83;
        }
        if(((total_u)> 83) && ((total_u)<= 88) ){
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
                  best->total_util=88;
        }
        if(((total_u)> 88) && ((total_u)<= 94) ){
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
               best->total_util=94;
        }
        if(((total_u)>94) ){
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);
               best->total_util=100;
        }

	if(flags & SCHED_FLAG_PI)
		best = get_pi_task(best, head, flags);

	return best;
}
struct rt_sched_local dra_ote = {
	.base.name = "DRA_OTE",
	.base.id = SCHED_RT_DRA_OTE,
	.flags = 0,
	.schedule = sched_dra_ote,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(dra_ote.base.list)
};

static int __init dra_ote_init(void)
{
	return add_local_scheduler(&dra_ote);
}
module_init(dra_ote_init);

static void __exit dra_ote_exit(void)
{
	remove_local_scheduler(&dra_ote);
}
module_exit(dra_ote_exit);

MODULE_DESCRIPTION("DRA_OTE Single-Core Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");

