#!/usr/bin/perl

use strict;
use warnings;
use POSIX;

my $newline;
my $count;
my $count2;
my $c;
my @clusters;
my $cpu;
my $numArgs = $#ARGV + 1;
my $filecount;

if($numArgs < 3)
{
	print "$numArgs\n";
	die $!;
}

for ($filecount = 2; $filecount < $numArgs; $filecount++) {
	my %lines;
	for ($count = 0; $count < $ARGV[0]; $count++) {
		$c = "";
		for ($count2 = 0; $count2 < $ARGV[1]; $count2++) {
			$cpu = $count2 + floor($count/$ARGV[1])*$ARGV[1];
			$c = $c . $cpu . ",";
		}
		chop($c);
		$clusters[$count] = $c;
	}

	$count = 0;
	open FILE, "$ARGV[$filecount]" or die $!;
	my $filename = ">" . $ARGV[$filecount] . "_c";
	my $opened = open NEWFILE, $filename;

	if( ! $opened ){
		print "Error!";
		close FILE;
		exit 1;
	}

	while (my $line = <FILE>) {
		if($count > 4) {
			my @values = split(' ',$line);
			$values[1] = $clusters[$values[1]];
			$newline = join('	',@values) . "\n";	
			print NEWFILE "$newline";
		} else {
			print NEWFILE "$line";
		}

		$count++;
	}

	close NEWFILE;
	close FILE;
}

exit 0;

