/* chronos/rtdvs/agr2.c
 *
 * AGR2 Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Sonal Saha, sonal3@vt.edu
 *
 * Copyright (C) 2009-2010 Virginia Tech Real Time Systems Lab
 */



#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <linux/time.h>
#include <linux/chronos_util.h>
#include <asm/current.h>
#include <linux/sched.h>
#include <linux/chronos_sched.h>
////////////////IMP!!!!!!!!!!!! task->buffer2 is remi!!!!!!!!!!!!!!!!!!!!!!!!!\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\


/*
struct alpha_member {
        int i;
        int i_end;
	unsigned long deadline;
        long left;
        long rem_time;
        unsigned long wcet_can;
      struct list_head list;
}; 
*/


struct dra_ote_member{

unsigned long deadline;
unsigned long period;
unsigned long next_arrival_time;

};

struct nta_member{

unsigned long deadline;
unsigned long period;
unsigned long next_arrival_time;

};

static long calc_left_dra(struct rt_info *task)
{
	long left = 0;

	left = 100*(task->exec_time)/(task->util_taskset) - task_time(task);//83
	return (left <= 0) ? 1 : left;
}

static long update_left_dra(struct rt_info *task)
{
	long left = 0;

	left = calc_left_dra(task);
	long_to_timespec(left, &(task->left));
	return left;
}

static int prev_high_speed;
static long end_high_int=0;
static int cnt=0,pl=0;
struct rt_info* sched_agr2(struct list_head *head, int flags)
{       
         int cpu=0;
         struct cpufreq_policy *policy=NULL;
         struct rt_info *it = NULL;
         long total_u=0;
         struct task_struct *p,*p1;
	 struct rt_info *task=NULL;
         struct rt_info *task1=NULL;
         int flag=0;
         long task_full_load=0;
         long task_prev_load=0;
         static long total_u_prev=0;
         struct mutex_data *mutex_k;
         policy=per_cpu(cpufreq_cpu_data,cpu);
         long max_blk_sec; 
         //int end_high_int;
         long deadline_blocking;
         static int cnt1=0;
         static int i=0;
         static int i_end=0;
       static struct alpha_member a[2000];
      // static struct alpha_member *b=NULL;
       struct alpha_member *it_alpha=NULL;
      long Req_Time;
      int prev_total_util;
  
    cnt++;
     p++;
        struct list_head *curr;
        struct rt_info *best_per = NULL, *last_per = NULL;
        int utilization, speed, high_speed;
         struct rt_info *prev_task=NULL;
     static   struct rt_info *head_temp=NULL;

       long  extra_time_fr_best=0;
       int check_flag=0;
       int task_q_counter=0;
          
        long Q,Q_actual,B;   
	long Z;
	long prev_Z;
	int count_ready_tasks=0;
	int count_tasks=0;
	
	int present_flag=0;
        int there_flag=0;
        

         p=current;
         task = &(p->rtinfo);
         struct rt_info *best = list_entry(head->next, struct rt_info, task_list[0]);
         flag=!list_empty(&task->task_list[0]);
          int Soptavg=best->mutex_flag;//just taking the case of 80% util and 0.8 wcet as of nws
         total_u =best->util_taskset;
       //  head_temp=head->next;
         struct list_head *pos, *q;
        static  struct alpha_member b;
         if (cnt==1) INIT_LIST_HEAD(&b.list);
         struct alpha_member *tmp,*tmp_next;
         struct list_head *ptr, *ptr_temp;
         struct alpha_member *entry, *entry_temp;
          int mark=0;
         struct timespec curr_time;
         static long prev_time;
         long time_diff;
        static long best_left;
         struct dra_ote_member d_curr[30];
         static struct dra_ote_member d_prev[30];
         int task_counter=0;
         static int initial_dra_counter=0;
        initial_dra_counter++;
        static struct nta_member nta[40];
        static long act_next_arrival_time=0;
        static int final_task_counter;
        int k=0;
         static  struct timespec curr_time_dra;
        static int i_flag=0;
    
// Will be required later for Agr1
  list_for_each(curr, head) {
              it = list_entry(curr, struct rt_info, task_list[0]);
                         if((it->total_util)==0){
                             if (i_flag==0){
                               i=0;
                               }
                           it->total_util=best->util_taskset;///check this value
                        }
                  i_flag=1;
           }
   

      if((flag==1)&&(task->flag_begin_end_check==200)){
                
               cnt1++;

               initialize_lists(task);
               
		   a[i].deadline = timespec_to_long(&(task->deadline));
		   a[i].i=i;
                   a[i].wcet_can=  ((task->exec_time)*100)/(best->util_taskset);//
                   a[i].rem_time=  ((task->exec_time)*100)/(best->util_taskset);//
            
                    pos=&b.list;
                   pos= pos->prev;
                   tmp=list_entry(pos, struct alpha_member, list);
                   curr_time = current_kernel_time();
                  
                      if (cnt1==1) prev_time=timespec_to_long(&(curr_time));
                 
               
                   time_diff=timespec_to_long(&(curr_time))-prev_time;
                    prev_time= timespec_to_long(&(curr_time));
                
                 
                   pos=&b.list;
                   pos= pos->prev;
      
          while(pos!= &b.list){
                         
		                tmp= list_entry(pos, struct alpha_member, list);
                                tmp->rem_time = tmp->rem_time - time_diff;
                                trace_printk("time_diff is= %ld\n",time_diff );
                                   if(tmp->rem_time >0)break;
                               list_del(pos);
                               trace_printk(" Deleting  i=%d\n",tmp->i);
                               pos=&b.list;
                               pos= pos->prev;
                               time_diff= (-1)*(tmp->rem_time);
		         }
                               

                   
		   b.deadline=10;
		   ptr= &b.list.next;
		   entry = list_entry(ptr, struct alpha_member, list);
		 
   
 
	     do {
		       mark=0;
		       ptr=ptr->next;
		       ptr_temp=ptr->next;
		       entry = list_entry(ptr, struct alpha_member, list);
			  if ( entry->deadline > a[i].deadline) {
				
				entry_temp = list_entry(ptr->next, struct alpha_member, list);
		  
					  while((a[i].deadline)<(entry_temp->deadline)&&(ptr!=&b.list)){

						  ptr=ptr_temp; 
						  ptr_temp=ptr_temp->next;
						 entry_temp = list_entry(ptr_temp, struct alpha_member, list);   
					  }

			      
				mark=1;
			       list_add(&(a[i].list), ptr);
			      break;
			   }
		
	       
	       }while(ptr!=&b.list);

            if (mark!=1)list_add(&(a[i].list), &(b.list));
     
                    i++;
                  
                trace_printk("the value of i = %d\n",i);
                trace_printk("Scheduler invoked from beginrtseg\n");

                
                        
              list_for_each(curr, head){
                  it = list_entry(curr, struct rt_info, task_list[0]);
           trace_printk("ACTUAL in begin :ddline =%ld and wcet =%ld and left=%ld\n",timespec_to_long(&(it->deadline)),((it->exec_time)*100/(it->util_taskset)), update_left_dra(it)); 
                }                


              list_for_each(pos, &b.list){
                        tmp= list_entry(pos, struct alpha_member, list);
                        tmp_next= list_entry(pos->next, struct alpha_member, list);
                        if((tmp->deadline==tmp_next->deadline)&&(tmp->wcet_can==tmp_next->wcet_can))list_del(pos);
                      
                       trace_printk("ALPHA_begin :ddline =%ld and i=%d and wcet_can =%ld and rem_time=%ld\n",tmp->deadline,tmp->i,tmp->wcet_can,tmp->rem_time); 

                 }      

                
                    trace_printk("ACTUAL_BEST_begin:ddline =%ld and wcet_can =%ld and left =%ld\n",timespec_to_long(&(best->deadline)),((best->exec_time)*100/83),update_left_dra(best)); 
                      best_left=update_left_dra(best);
         
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 curr_time = current_kernel_time();
   trace_printk("Current kernel time is = %ld\n",timespec_to_long(&(curr_time)));
     list_for_each(curr, head){
		      it = list_entry(curr, struct rt_info, task_list[0]);
		      d_curr[task_counter].deadline=timespec_to_long(&(it->deadline));
		      d_curr[task_counter].period=timespec_to_long(&(it->period));
		      d_curr[task_counter].next_arrival_time= timespec_to_long(&(curr_time))+ d_curr[task_counter].period;

		       if(initial_dra_counter!=1){
		            for(k=0;k<=final_task_counter;k++){
                           //   trace_printk("nta[%d].period=%ld,nta[%d].next_arrival_time=%ld\n",k,nta[k].period,k,nta[k].next_arrival_time); 
		            	 if((d_curr[task_counter].period==nta[k].period)&&(d_curr[task_counter].deadline!=nta[k].deadline)){
		                   	  if(d_curr[task_counter].next_arrival_time>=nta[k].next_arrival_time){
		                     	     nta[k].next_arrival_time=d_curr[task_counter].next_arrival_time;
		                    	   }
                                 }
		             } 
		       }
              
        		  if ( initial_dra_counter==1){
               				nta[task_counter].period= timespec_to_long(&(it->period));       
               				nta[task_counter].next_arrival_time=d_curr[task_counter].next_arrival_time;
                                        nta[task_counter].deadline=d_curr[task_counter].deadline;
                                       final_task_counter=task_counter;
                                   trace_printk("final_task_counter=%d\n",final_task_counter);
                           }
              task_counter++;
      }

          if(initial_dra_counter!=1){
                 for(k=0;k<=final_task_counter;k++){
                      trace_printk("nta[%d].period=%ld,nta[%d].next_arrival_time=%ld\n",k,nta[k].period,k,nta[k].next_arrival_time); 
                  }
           }   


		 if ( initial_dra_counter==1){
		      for (k=0;k<task_counter;k++){
		              trace_printk("nta[%d].period=%ld,nta[%d].next_arrival_time=%ld\n",k,nta[k].period,k,nta[k].next_arrival_time); 
		       }
		  }
     int j=0;
          act_next_arrival_time=nta[0].next_arrival_time;
        if(initial_dra_counter!=1){
		  for(j=0;j<final_task_counter;j++){
		             act_next_arrival_time=(nta[j].next_arrival_time < act_next_arrival_time)?nta[j].next_arrival_time:act_next_arrival_time;       
		    }
          }
        trace_printk("act_next_arrival_time=%ld\n",act_next_arrival_time);      
     curr_time_dra = current_kernel_time();
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    }        

         

    if(task->flag_begin_end_check==100){
              trace_printk("Scheduler invoked from  endrtseg\n");

           //    list_del(&task->a_mem.list);

                   pos=&b.list;
                   pos= pos->prev;
                   tmp=list_entry(pos, struct alpha_member, list);
                   curr_time = current_kernel_time();
                   //   if (cnt1==1) prev_time=timespec_to_long(&(curr_time));
               
               //       trace_printk("end:: prev_time= %ld\n",prev_time);
                 //     trace_printk("end:: curr_time = %ld\n",timespec_to_long(&(curr_time)));
               
                   time_diff=timespec_to_long(&(curr_time))-prev_time;
                    prev_time= timespec_to_long(&(curr_time));


             
                   pos=&b.list;
                   pos= pos->prev;
      
     while(pos!= &b.list){
                         
		                tmp= list_entry(pos, struct alpha_member, list);
                                tmp->rem_time = tmp->rem_time - time_diff;
                    trace_printk("time_diff is= %ld\n",time_diff );
                    //trace_printk("HEAD1 in end ::alpha_mmber.ddline =%ld i=%d wcet_can=%ld rem_t=%ld\n",tmp->deadline,tmp->i,tmp->wcet_can,tmp->rem_time);
                                   if(tmp->rem_time >0)break;
                                  list_del(pos);
                                 trace_printk(" Deleting  i=%d\n",tmp->i); 
                                    pos=&b.list;
                                    pos= pos->prev;
                                 time_diff= (-1)*(tmp->rem_time);
		       }

                 list_for_each(curr, head){
                  it = list_entry(curr, struct rt_info, task_list[0]);
           trace_printk("ACTUAL in end :ddline =%ld and wcet =%ld and left=%ld\n",timespec_to_long(&(it->deadline)),((it->exec_time)*100/(it->util_taskset)),update_left_dra(it)); 
                }  


                    list_for_each(pos, &b.list){
                        tmp= list_entry(pos, struct alpha_member, list);
                       trace_printk("ALPHA_END:ddline =%ld and i=%d and wcet_can =%ld and rem_time=%ld\n",tmp->deadline,tmp->i,tmp->wcet_can,tmp->rem_time); 

                 }             

                 i_end++;
       trace_printk("ACTUAL_BEST_end:ddline =%ld and wcet_can =%ld and left =%ld\n",timespec_to_long(&(best->deadline)),((best->exec_time)*100/(it->util_taskset)),update_left_dra(best)); 

         best_left=update_left_dra(best);   
        curr_time_dra = current_kernel_time();         
       }
         
         
          
if((task->flag_begin_end_check==200)||(task->flag_begin_end_check==100)){  
                 extra_time_fr_best=0;
                 check_flag=0;

                
	    if (list_empty(&b.list)==0){

		      list_for_each_prev(pos, &b.list){

			   tmp= list_entry(pos, struct alpha_member, list);

				//        if((best->deadline>tmp->deadline)&&(((100*best->exec_time)/83)==tmp->wcet_can)){
			   if(timespec_to_long(&(best->deadline))>tmp->deadline){
			      extra_time_fr_best= extra_time_fr_best+ tmp->rem_time;
			    }
				             
			    if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)!=tmp->wcet_can)&&(check_flag==0)){
				extra_time_fr_best= extra_time_fr_best+ tmp->rem_time;
			    }

			     if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)==tmp->wcet_can)){
				   extra_time_fr_best= extra_time_fr_best+ tmp->rem_time;
				   check_flag=1;
				   break;
			     }

		       }   

	    }
              
/* DRA_OTE and AGR starts from here */
/*   
		  if(extra_time_fr_best==0){
                        total_u=1000*best->util_taskset;
                   }
		   else{
		        total_u=1000* (best->util_taskset*(best_left))/extra_time_fr_best;
		   } 
		     total_u=total_u/1000;
		  
		// if(total_u >best->util_taskset)total_u=best->util_taskset;

		  trace_printk(" total_u_aftr normal computation=%d\n", total_u);
*/ 
                  trace_printk(" best->total_util=%d\n",best->total_util);
                   if(extra_time_fr_best==0){
                        total_u=1000*best->total_util;
                   }
		   else{
		        total_u=1000* ((best->total_util)*(best_left))/(extra_time_fr_best);
		   } 
		     total_u=total_u/1000;
		  
		// if(total_u >best->util_taskset)total_u=best->util_taskset;
		  trace_printk(" total_u_after normal computation=%d\n", total_u);

// DRA-OTE starts from here
         	task_q_counter=0;
			 list_for_each(curr, head){
			    	task_q_counter++;
			    }
   
     
	    if (task_q_counter==1){
	   //     curr_time = current_kernel_time();
			trace_printk("Current kernel time is = %ld\n",timespec_to_long(&(curr_time_dra)));
			trace_printk("act_next_arrival_time = %ld\n",act_next_arrival_time);
			extra_time_fr_best=act_next_arrival_time-timespec_to_long(&(curr_time_dra));
			trace_printk("extra_time_fr_best = %ld\n",extra_time_fr_best);
			trace_printk("best_left = %ld\n",best_left);
			       if (extra_time_fr_best>best_left){
				  	 total_u=1000* (total_u*(best_left))/extra_time_fr_best;
				 }
		       	     else total_u=1000*total_u;
		    
			total_u=total_u/1000;
                    trace_printk(" total_u_after dra_ote computation=%d\n", total_u);

                        goto end;
	      }
 /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////   
/*long Q,Q_actual,B;   
long Z;
long prev_Z;
int count_ready_tasks=0;
int count_tasks=0;
int Soptavg=64;//just taking the case of 80% util and 0.8 wcet as of nws
int present_flag=0;*/

		count_ready_tasks=0;
		count_tasks=0;
		check_flag=0;
		Soptavg=best->mutex_flag;
         trace_printk(" Soptvag=%d\n", Soptavg);
		present_flag=0;
                Q=0;
                B=0;

trace_printk(" total_u_ before agr computation=%d\n", total_u);
   while(task_q_counter!=1){
               
                  if(total_u < Soptavg) total_u = Soptavg;

		    if ((total_u < Soptavg)||(total_u< 49)){
			       //break;
                          goto end;
		     }
	    if(Soptavg<49)Soptavg=49;
	     
		//    Q= ((100*(best->util_taskset))/(100*Soptavg)-1)(best_left);
                     Q= best_left*(best->util_taskset)/(Soptavg) -best_left;
                trace_printk("best_left = %ld\n",best_left);
            trace_printk(" Q_before =%ld \n",Q); 
          //    trace_printk(" act_next_arrival_time =%ld \n",act_next_arrival_time); 
           //  trace_printk("timespec_to_long(&(curr_time_dra))=%ld \n",timespec_to_long(&(curr_time_dra)));
		    extra_time_fr_best =   act_next_arrival_time-timespec_to_long(&(curr_time_dra))-best_left;
                 if (extra_time_fr_best<0) goto end;
		    if (extra_time_fr_best < Q) Q = extra_time_fr_best;  
                      trace_printk(" Q_after =%ld \n",Q); 
		    Q_actual=0;
	   // Check both the ready queue and the alpha_queue for the next Trs
	    // Handling the alpha queue
	   // 1st check the alpha queuehe and then continue from the ready queue

	    Z=0;
            

	    list_for_each_prev(pos, &b.list){
	             tmp= list_entry(pos, struct alpha_member, list);

		            prev_Z=Z;

		           // higher priority than the ready task...nothing to do....continues
		             if(timespec_to_long(&(best->deadline))>tmp->deadline){
		                   continue;  
		              }
		           
		           // higher priority than the ready task even wen it has the same deadline as the ready task        
		            if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)!=tmp->wcet_can)&&(check_flag==0)){
		               continue;         
		              }

		         // the ready task
		           if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)==tmp->wcet_can)){
		                           check_flag=1;
		                           continue;
		                        
		              }

		           // lower priority than the ready task with the same deadline
		          if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)!=tmp->wcet_can)&&(check_flag==1)){
		                          present_flag=0;
		               /* Checking whether it is in the ready queue, otherwise it has already completed*/
		                       list_for_each(curr, head){
				            it = list_entry(curr, struct rt_info, task_list[0]);
				if((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)){
		                                           Z=Z +update_left_dra(it);
		                                              present_flag=1;
		                                             break;
						    }
				        }
		                if(present_flag!=1)Z= Z + tmp->rem_time;
				       trace_printk("Z =%ld inside alpha q 1\n",Z);
		           }
		              
		                 

		           // lower priority as it is
		             if(timespec_to_long(&(best->deadline))<tmp->deadline){
		                         present_flag=0;
		                     list_for_each(curr, head){
				            it = list_entry(curr, struct rt_info, task_list[0]);
		         if((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)){
							   Z=Z +update_left_dra(it);
		                                             present_flag=1;
		                                             break;
						    }
				        }
		                   if(present_flag!=1)Z= Z + tmp->rem_time; 
		                    trace_printk("Z =%ld inside alpha q 2\n",Z);
		              }

		           
		      count_ready_tasks++;
		         if (Z  > Q ){
		                Z= prev_Z;
		                     count_ready_tasks--;
                                 goto next;
		                 break;
		         }


	   }//end of list_for_each_prev
	///contine with the ready queue
 
     trace_printk("Z =%ld before going to ready q\n",Z);
     trace_printk("count_ready_tasks=%d before going to ready q\n",count_ready_tasks);
  
      trace_printk(" last in the alpha_queue:: tmp->ddline =%ld and tmp-> wcet_can =%ld \n",tmp->deadline,tmp->wcet_can); 
                   
	 there_flag=0;
		  list_for_each(curr, head){
			   it = list_entry(curr, struct rt_info, task_list[0]);
		                prev_Z=Z;
		           //    if((it!=tmp)&&(there_flag==0))continue;
			    
             if((!((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)))&&(there_flag==0))continue;


			       if((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)){
  trace_printk(" same as last in the alpha_queue but in ready q:: it->ddline =%ld and it-> exec_time =%ld \n",timespec_to_long(&(it->deadline)),((it->exec_time)*100/(it->util_taskset))); 
					 there_flag=1;
				        continue;
			       }
		        
			      // if((it!=tmp)&&(there_flag==1)) {
  if((!((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)))&&(there_flag==1)){
               trace_printk(" All the ones thereaftr in ready q:: it->ddline =%ld and it-> exec_time =%ld \n",timespec_to_long(&(it->deadline)),((it->exec_time)*100/(it->util_taskset))); 
				       Z=Z+update_left_dra(it);
                                trace_printk("Z =%ld inside ready q\n",Z);
			       }         
		        
                          count_ready_tasks++;
			       if (Z  > Q ){
		                       count_ready_tasks--;
				        Z= prev_Z;
                                      goto next;
				         break;
			      }
		      

		   }//end of list_for_each
        break;
	   
	//}//end of while
next:
    trace_printk(" Z  after coming out of the ready q= %ld\n",Z);
    trace_printk(" count_ready_tasks = %d\n after ready q",count_ready_tasks);


//}//end of if 

    

list_for_each_prev(pos, &b.list){
    tmp= list_entry(pos, struct alpha_member, list);

      if(count_tasks>count_ready_tasks)break;

                 if (count_tasks<count_ready_tasks){
                    Req_Time = Q- Q_actual;
                   }
                 else
                    Req_Time= Q-Z;
                    
                   // higher priority than the ready task...nothing to do....continues
                     if(timespec_to_long(&(best->deadline))>tmp->deadline){
                           continue;  
                      }
                   
                   // higher priority than the ready task even wen it has the same deadline as the ready task        
                     if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)!=tmp->wcet_can)&&(check_flag==0)){
                       continue;         
                      }

                 // the ready task
                   if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)==tmp->wcet_can)){
                                   check_flag=1;
                                   continue;
                                
                      }

                   // lower priority than the ready task with the same deadline
                  if((timespec_to_long(&(best->deadline))==tmp->deadline)&&(((100*best->exec_time)/best->util_taskset)!=tmp->wcet_can)&&(check_flag==1)){
                           list_for_each(curr, head){
                                     present_flag=0;
		                    it = list_entry(curr, struct rt_info, task_list[0]);
		if((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)){
                                          trace_printk(" it->total_util before in alpha q 1=%d\n",it->total_util);
			                   prev_total_util=it->total_util;
		                            it->total_util= (1000*(it->total_util)*update_left_dra(it))/(( update_left_dra(it)-Req_Time)*1000);
                                            B= (it->total_util/prev_total_util)*update_left_dra(it) -update_left_dra(it);
                                            trace_printk(" it->total_util after in alpha q 1=%d\n",it->total_util);
                                            if (it->total_util >94)it->total_util=94;
		                            present_flag=1;                          
					    break;
					    }
		           }

                       if(present_flag!=1){
                             B = ((tmp->rem_time) < (Req_Time))? (tmp->rem_time):(Req_Time);  
                        }

                         trace_printk(" B in alpha q 2=%ld\n", B);
                   }
                      
                         

                   // lower priority as it is
                     if(timespec_to_long(&(best->deadline))<tmp->deadline){
                             present_flag=0;
                          list_for_each(curr, head){
		                    it = list_entry(curr, struct rt_info, task_list[0]);
   				if((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)){
                                            trace_printk(" it->total_util before in alpha q 2=%d\n",it->total_util);
					    prev_total_util=it->total_util;
		                            it->total_util= (1000*(it->total_util)*update_left_dra(it))/(( update_left_dra(it)-Req_Time)*1000);
                                            B= (it->total_util/prev_total_util)*update_left_dra(it) -update_left_dra(it);
                                              trace_printk(" it->total_util after in alpha q 2=%d\n",it->total_util);
                                               if (it->total_util >94)it->total_util=94;
		                            present_flag=1;                          
					    break;
					    }
		           }
                           
                        if(present_flag!=1){
                            B = ((tmp->rem_time) < (Req_Time))? (tmp->rem_time):(Req_Time);
                        }
                        trace_printk(" B in alpha q 1 =%ld\n", B);
 
                      }

                   
           Q_actual= Q_actual + B;
           count_tasks++;


   }
  
    int there_flag=0;
          list_for_each(curr, head){
          
       if(count_tasks>count_ready_tasks)break;
      
               if (count_tasks<count_ready_tasks){
                    Req_Time = Q- Q_actual;
                   }
                 else
                    Req_Time= Q-Z;
               //  if(count_tasks>count_ready_tasks)break;


		   it = list_entry(curr, struct rt_info, task_list[0]);
             
                   if((!((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)))&&(there_flag==0))continue;
		    
		     if((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)){
				 there_flag=1;
		                continue;
		       }
                
		       if((!((timespec_to_long(&(it->deadline))==tmp->deadline)&&(((100*it->exec_time)/it->util_taskset)==tmp->wcet_can)))&&(there_flag==1)){
		                            prev_total_util=it->total_util;
                                            trace_printk(" it->total_util before in ready q=%d\n",it->total_util);
		                            it->total_util= (1000*(it->total_util)*update_left_dra(it))/(( update_left_dra(it)-Req_Time)*1000);
                                              trace_printk(" update_left_dra(it)=%ld\n",update_left_dra(it));
                                             trace_printk(" Req_Time=%ld\n",Req_Time);
                                               trace_printk(" it->total_util after in ready q=%d\n",it->total_util);
                                            B= ((it->total_util*update_left_dra(it))/prev_total_util) - update_left_dra(it);
                                             if (it->total_util >94)it->total_util=94;
 		                            trace_printk(" B n ready q=%ld\n", B);
		       }         
       
               Q_actual= Q_actual + B;              
                       count_tasks++;

           }

    total_u = total_u=(1000*total_u*(best_left))/(B+best_left);
    trace_printk(" best_left=%ld\n", best_left);
    trace_printk(" B at end=%ld\n", B);
    total_u=total_u/1000;
  trace_printk(" total_u_after agr computation=%d\n", total_u);
    break;

 }//end of the big while

}//end of if
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


 if((task->flag_begin_end_check!=100)&&(flag!=1)){
        total_u=total_u_prev;
         }  
end:
total_u_prev=total_u;



      trace_printk(" total_u_end=%d\n", total_u);
        if((total_u)<= 49){
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);
           //best->total_util=49;
        }  
        if(((total_u)> 49) && ((total_u)<= 55) ){
             __cpufreq_driver_target(policy, 1380000,CPUFREQ_RELATION_H);
             // best->total_util=55;
        }
        if(((total_u)> 55) && ((total_u)<= 61) ){
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
              //best->total_util=61;
        }

        if(((total_u)> 61) && ((total_u)<= 66) ){
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
              //best->total_util=66;
        }
        if(((total_u)> 66) && ((total_u)<= 72) ){
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
               // best->total_util=72;
        }
        if(((total_u)> 72) && ((total_u)<= 77) ){
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
             //best->total_util=77;
        }
        if(((total_u)> 77) && ((total_u)<= 83) ){
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
             //best->total_util=83;
        }
        if(((total_u)> 83) && ((total_u)<= 88) ){
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
                 // best->total_util=88;
        }
        if(((total_u)> 88) && ((total_u)<= 94) ){
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
               //best->total_util=94;
        }
        if(((total_u)>94) ){
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);
             //  best->total_util=100;
        }

	if(flags & SCHED_FLAG_PI)
		best = get_pi_task(best, head, flags);

	return best;
}

struct rt_sched_local agr2 = {
	.base.name = "AGR2",
	.base.id = SCHED_RT_AGR2,
	.flags = 0,
	.schedule = sched_agr2,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(agr2.base.list)
};

static int __init agr2_init(void)
{
	return add_local_scheduler(&agr2);
}
module_init(agr2_init);

static void __exit agr2_exit(void)
{
	remove_local_scheduler(&agr2);
}
module_exit(agr2_exit);

MODULE_DESCRIPTION("AGR2 Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");
