/* chronos/rtdvs/usfi_edf.c
 *
 * USFI-EDF Single-Core Scheduler Module for ChronOS
 *
 * Author(s)
 *	- Sonal Saha, sonal3@vt.edu
 *
 * Copyright (C) 2009-2011 Virginia Tech Real Time Systems Lab
 */

#include <linux/module.h>
#include <linux/chronos_types.h>
#include <linux/chronos_sched.h>
#include <linux/list.h>
#include <linux/cpufreq.h>
#include <asm/current.h>


static int cnt1 =0;
static int task_cnt=0;
struct rt_info* sched_usfi_edf(struct list_head *head, int flags)
{

          int cpu=0;
          struct cpufreq_policy *policy=NULL;
       //  int task_cnt=0;
          struct list_head *curr;
          struct rt_info *it = NULL;
          int i;
          int *n_freq_ptr;
  struct rt_info *best = local_task(head->next);
          n_freq_ptr=best->n_freq;
      static  int n[20];  
  
  cnt1++;
	 if(cnt1==1){
	    list_for_each(curr, head) {
             it = list_entry(curr, struct rt_info, task_list[0]);    
                 task_cnt++;
                 
                it->high_freq=*n_freq_ptr;
                   n[i]=*n_freq_ptr;
                  *n_freq_ptr++;    
            trace_printk(" it->high_freq=%d\n", it->high_freq);   
           trace_printk(" n[%d]=%d\n",i,n[i]);   
              i++;
           trace_printk(" it->period=%ld\n", timespec_to_long(&(it->period)));         
		   }
	 }

   list_for_each(curr, head) {
      it = list_entry(curr, struct rt_info, task_list[0]);  
     if(timespec_to_long(&(it->period))==500000)it->high_freq=n[0];
     if(timespec_to_long(&(it->period))==1000000)it->high_freq=n[1];
     if(timespec_to_long(&(it->period))==1500000)it->high_freq=n[2];
     if(timespec_to_long(&(it->period))==3000000)it->high_freq=n[3];
     if(timespec_to_long(&(it->period))==5000000)it->high_freq=n[4];
  
      trace_printk(" it->period=%ld\n", timespec_to_long(&(it->period))); 
      trace_printk(" it->high_freq=%d\n", it->high_freq);    
  }

 for (i=0;i<task_cnt;i++){
  
 trace_printk(" n[%d]=%d\n", i,n[i]);   

 }

  trace_printk(" task_cnt=%d\n", task_cnt);

	
       policy=per_cpu(cpufreq_cpu_data,cpu);

    struct mutex_data *mutex_k1;
     struct mutex_data *mutex_k2;
     struct task_struct *p,*p1;
    struct rt_info *task1=NULL;
    int total_u = best->high_freq;
   
    
   trace_printk(" best->mutex0->owner=%d\n", best->mutex0->owner);
  trace_printk(" best->mutex1->owner=%d\n", best->mutex1->owner);
  trace_printk(" best->buffer2=%ld\n", best->buffer2);
  trace_printk(" best->buffer3=%ld\n", best->buffer3);

 if(best->buffer2==0){
   if(best->mutex0->owner!=0){
                    p1=find_task_by_vpid(best->mutex0->owner);
                    task1=&(p1->rtinfo);
               trace_printk(" before in buffer2 : best->exec_time=%ld\n", best->exec_time);
                if(best!=task1){
                    best=task1;
               //     total_u =best->high_freq;
                 trace_printk(" after in buffer2 : best->exec_time=%ld\n", best->exec_time);
                   }
             } 

    }

  if(best->buffer3==0){
   if(best->mutex1->owner!=0){
                    p1=find_task_by_vpid(best->mutex1->owner);
                    task1=&(p1->rtinfo);
         trace_printk(" before in buffer3 : best->exec_time=%ld\n", best->exec_time);
                if(best!=task1){
                    best=task1;
                  //  total_u =best->high_freq;
           trace_printk(" after in buffer3 : best->exec_time=%ld\n", best->exec_time);
                   }
             } 

    }


//   trace_printk(" best->mutex0=%ld\n", best->mutex0);
  // trace_printk(" best->mutex1=%ld\n", best->mutex1);

//     trace_printk(" best->util_taskset=%d\n", best->util_taskset);
 best->util_taskset=total_u;
 trace_printk(" best->util_taskset=%d\n", best->util_taskset);
        if((best->util_taskset)<= 49)
           __cpufreq_driver_target(policy, 1200000,CPUFREQ_RELATION_H);  
        if(((best->util_taskset)> 49) && ((best->util_taskset)<= 55) )
             __cpufreq_driver_target(policy, 1330000,CPUFREQ_RELATION_H);
        if(((best->util_taskset)> 55) && ((best->util_taskset)<= 61) )
             __cpufreq_driver_target(policy, 1470000,CPUFREQ_RELATION_H);
        if(((best->util_taskset)> 61) && ((best->util_taskset)<= 66) )
             __cpufreq_driver_target(policy, 1600000,CPUFREQ_RELATION_H);
        if(((best->util_taskset)> 66) && ((best->util_taskset)<= 72) )
             __cpufreq_driver_target(policy, 1730000,CPUFREQ_RELATION_L);
        if(((best->util_taskset)> 72) && ((best->util_taskset)<= 77) )
             __cpufreq_driver_target(policy, 1870000,CPUFREQ_RELATION_H);
        if(((best->util_taskset)> 77) && ((best->util_taskset)<= 83) )
             __cpufreq_driver_target(policy, 2000000,CPUFREQ_RELATION_H);
        if(((best->util_taskset)> 83) && ((best->util_taskset)<= 88) )
             __cpufreq_driver_target(policy, 2130000,CPUFREQ_RELATION_L);
        if(((best->util_taskset)> 88) && ((best->util_taskset)<= 94) )
             __cpufreq_driver_target(policy, 2270000,CPUFREQ_RELATION_H);
        if(((best->util_taskset)>94) )
             __cpufreq_driver_target(policy, 2400000,CPUFREQ_RELATION_H);


	//(flags & SCHED_FLAG_PI)
	//	best = get_pi_task(best, head, flags);

	return best;
}

struct rt_sched_local usfi_edf = {
	.base.name = "USFI_EDF",
	.base.id = SCHED_RT_USFI_EDF,
	.flags = 0,
	.schedule = sched_usfi_edf,
	.base.sort_key = SORT_KEY_DEADLINE,
	.base.list = LIST_HEAD_INIT(usfi_edf.base.list)
};

static int __init usfi_edf_init(void)
{
	return add_local_scheduler(&usfi_edf);
}
module_init(usfi_edf_init);

static void __exit usfi_edf_exit(void)
{
	remove_local_scheduler(&usfi_edf);
}
module_exit(usfi_edf_exit);

MODULE_DESCRIPTION("USFI_EDF Single-Core Scheduling Module for ChronOS");
MODULE_AUTHOR("Sonal Saha <sonal3@vt.edu>");
MODULE_LICENSE("GPL");
